=== dev/test/router/easy_parser_path_to_params/CMakeLists.txt ===
set(UNITTEST _unit.test.router.easy_parser_path_to_params)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)
